## mingw-w64-qt6-graphs-6.6.3-1.src.tar.zst

=== src/graphs/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only WITH Qt-GPL-exception-1.0

set(qml_files
    "qml/designer/Bars3DSpecifics.qml"
    "qml/designer/Scatter3DSpecifics.qml"
    "qml/designer/Surface3DSpecifics.qml"
    "qml/designer/GraphsCameraSection.qml"
    "qml/designer/GraphsSection.qml"
    "qml/designer/default/Bars3D.qml"
    "qml/designer/default/Scatter3D.qml"
    "qml/designer/default/Surface3D.qml"
)

set_source_files_properties(${qml_files} PROPERTIES
    QT_QML_SKIP_QMLDIR_ENTRY TRUE
)

qt_internal_add_qml_module(Graphs
    URI "QtGraphs"
    TARGET_PRODUCT "Qt Graphs (Qt $$QT_VERSION)"
    TARGET_DESCRIPTION "Qt Graphs 3D Visualization component for Qt."
    VERSION "${PROJECT_VERSION}"
    PAST_MAJOR_VERSIONS 1
    DEPENDENCIES
        QtQuick
        QtQuick3D
        QML_FILES
            ${qml_files}
    SOURCES
        axis/qabstract3daxis.cpp axis/qabstract3daxis.h axis/qabstract3daxis_p.h
        axis/qcategory3daxis.cpp axis/qcategory3daxis.h axis/qcategory3daxis_p.h
        axis/qlogvalue3daxisformatter.cpp axis/qlogvalue3daxisformatter.h axis/qlogvalue3daxisformatter_p.h
        axis/qvalue3daxis.cpp axis/qvalue3daxis.h axis/qvalue3daxis_p.h
        axis/qvalue3daxisformatter.cpp axis/qvalue3daxisformatter.h axis/qvalue3daxisformatter_p.h

        data/abstractitemmodelhandler.cpp data/abstractitemmodelhandler_p.h
        data/baritemmodelhandler.cpp data/baritemmodelhandler_p.h
        data/qabstract3dseries.cpp data/qabstract3dseries.h data/qabstract3dseries_p.h
        data/qabstractdataproxy.cpp data/qabstractdataproxy.h data/qabstractdataproxy_p.h
        data/qbar3dseries.cpp data/qbar3dseries.h data/qbar3dseries_p.h
        data/qbardataitem.cpp data/qbardataitem.h data/qbardataitem_p.h
        data/qbardataproxy.cpp data/qbardataproxy.h data/qbardataproxy_p.h
        data/qcustom3ditem.cpp data/qcustom3ditem.h data/qcustom3ditem_p.h
        data/qcustom3dlabel.cpp data/qcustom3dlabel.h data/qcustom3dlabel_p.h
        data/qcustom3dvolume.cpp data/qcustom3dvolume.h data/qcustom3dvolume_p.h
        data/qheightmapsurfacedataproxy.cpp data/qheightmapsurfacedataproxy.h data/qheightmapsurfacedataproxy_p.h
        data/qitemmodelbardataproxy.cpp data/qitemmodelbardataproxy.h data/qitemmodelbardataproxy_p.h
        data/qitemmodelscatterdataproxy.cpp data/qitemmodelscatterdataproxy.h data/qitemmodelscatterdataproxy_p.h
        data/qitemmodelsurfacedataproxy.cpp data/qitemmodelsurfacedataproxy.h data/qitemmodelsurfacedataproxy_p.h
        data/qscatter3dseries.cpp data/qscatter3dseries.h data/qscatter3dseries_p.h
        data/qscatterdataitem.cpp data/qscatterdataitem.h data/qscatterdataitem_p.h
        data/qscatterdataproxy.cpp data/qscatterdataproxy.h data/qscatterdataproxy_p.h
        data/qsurface3dseries.cpp data/qsurface3dseries.h data/qsurface3dseries_p.h
        data/qsurfacedataitem.cpp data/qsurfacedataitem.h data/qsurfacedataitem_p.h
        data/qsurfacedataproxy.cpp data/qsurfacedataproxy.h data/qsurfacedataproxy_p.h
        data/scatteritemmodelhandler.cpp data/scatteritemmodelhandler_p.h
        data/surfaceitemmodelhandler.cpp data/surfaceitemmodelhandler_p.h

        engine/abstract3dcontroller.cpp engine/abstract3dcontroller_p.h
        engine/axishelper.cpp engine/axishelper_p.h
        engine/bars3dcontroller.cpp engine/bars3dcontroller_p.h
        engine/barinstancing.cpp engine/barinstancing_p.h
        engine/scatterinstancing.cpp engine/scatterinstancing_p.h
        engine/q3dbars.cpp engine/q3dbars.h
        engine/q3dcamera.cpp engine/q3dcamera.h engine/q3dcamera_p.h
        engine/q3dlight.cpp engine/q3dlight.h engine/q3dlight_p.h
        engine/q3dobject.cpp engine/q3dobject.h engine/q3dobject_p.h
        engine/q3dscatter.cpp engine/q3dscatter.h
        engine/q3dscene.cpp engine/q3dscene.h engine/q3dscene_p.h
        engine/q3dsurface.cpp engine/q3dsurface.h
        engine/qabstract3dgraph.cpp engine/qabstract3dgraph.h
        engine/scatter3dcontroller.cpp engine/scatter3dcontroller_p.h
        engine/surface3dcontroller.cpp engine/surface3dcontroller_p.h
        engine/surfaceselectioninstancing.cpp engine/surfaceselectioninstancing_p.h

        global/graphsglobal_p.h
        global/qgraphsglobal.h

        input/q3dinputhandler.cpp input/q3dinputhandler.h input/q3dinputhandler_p.h
        input/qabstract3dinputhandler.cpp input/qabstract3dinputhandler.h input/qabstract3dinputhandler_p.h
        input/qtouch3dinputhandler.cpp input/qtouch3dinputhandler.h input/qtouch3dinputhandler_p.h

        theme/q3dtheme.cpp theme/q3dtheme.h theme/q3dtheme_p.h
        theme/thememanager.cpp theme/thememanager_p.h

        utils/qutils.h
        utils/utils.cpp utils/utils_p.h

        qml/foreigntypes_p.h
        qml/colorgradient.cpp qml/colorgradient_p.h
        qml/declarativecolor.cpp qml/declarativecolor_p.h
        qml/declarativescene.cpp qml/declarativescene_p.h
        qml/declarativeseries.cpp qml/declarativeseries_p.h
        qml/declarativetheme.cpp qml/declarativetheme_p.h
        qml/qquickgraphsitem.cpp qml/qquickgraphsitem_p.h
        qml/qquickgraphsbars.cpp qml/qquickgraphsbars_p.h
        qml/qquickgraphssurface.cpp qml/qquickgraphssurface_p.h
        qml/qquickgraphsscatter.cpp qml/qquickgraphsscatter_p.h
        qml/quickgraphstexturedata.cpp qml/quickgraphstexturedata_p.h
    NO_UNITY_BUILD_SOURCES
        # Symbol collision with, `qtouch3dinputhandler.cpp`
        # TODO: Resolve `rotationSpeed` symbol redefinition
        input/q3dinputhandler.cpp
        # Symbol collision with, `surfaceitemmodelhandler.cpp`
        # TODO: Resolve `noRoleIndex` symbol redefinition
        data/baritemmodelhandler.cpp
        data/scatteritemmodelhandler.cpp
        # QScatterDataItem::d_ptr' may be used uninitialized [-Werror=maybe-uninitialized]
        # TODO: Redo QScatterDataItem copy constructor, without using operator=()
        #       Similar issue exists in `qtdatavis3d`.
        data/qbardataitem.cpp
        data/qscatterdataitem.cpp
        data/qsurfacedataitem.cpp
    INCLUDE_DIRECTORIES
        axis
        data
        engine
        global
        input
        theme
        utils
        qml
    LIBRARIES
        Qt::Quick3DPrivate
        Qt::Quick3DRuntimeRenderPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
        Qt::Quick
        Qt::QuickWidgets
        Qt::Quick3D
    PRIVATE_MODULE_INTERFACE
        Qt::Quick3DPrivate
        Qt::Quick3DRuntimeRenderPrivate
    GENERATE_CPP_EXPORTS
)
set_source_files_properties("qml/resources/DatapointSphere.qml"
    PROPERTIES QT_RESOURCE_ALIAS "DatapointSphere"
)

set_source_files_properties("qml/resources/DatapointCube.qml"
    PROPERTIES QT_RESOURCE_ALIAS "DatapointCube"
)

set_source_files_properties("qml/resources/AxisLabel.qml"
    PROPERTIES QT_RESOURCE_ALIAS "AxisLabel"
)

set_source_files_properties("qml/resources/GridLine.qml"
    PROPERTIES QT_RESOURCE_ALIAS "GridLine"
)

set_source_files_properties("qml/resources/ItemLabel.qml"
    PROPERTIES QT_RESOURCE_ALIAS "ItemLabel"
)

set_source_files_properties("qml/resources/TitleLabel.qml"
    PROPERTIES QT_RESOURCE_ALIAS "TitleLabel"
)

set_source_files_properties("qml/resources/RangeGradientMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "RangeGradientMaterial"
)
set_source_files_properties("qml/resources/RangeGradientMaterialInstancing.qml"
    PROPERTIES QT_RESOURCE_ALIAS "RangeGradientMaterialInstancing"
)
set_source_files_properties("qml/resources/RangeGradientScatterMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "RangeGradientScatterMaterial"
)
set_source_files_properties("qml/resources/RangeGradientScatterMaterialInstancing.qml"
    PROPERTIES QT_RESOURCE_ALIAS "RangeGradientScatterMaterialInstancing"
)
set_source_files_properties("qml/resources/GridSurfaceMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "GridSurfaceMaterial"
)
set_source_files_properties("qml/resources/SurfaceSliceMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "SurfaceSliceMaterial"
)
set_source_files_properties("qml/resources/SurfaceMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "SurfaceMaterial"
)
set_source_files_properties("qml/resources/ObjectGradientMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "ObjectGradientMaterial"
)
set_source_files_properties("qml/resources/ObjectGradientMaterialInstancing.qml"
    PROPERTIES QT_RESOURCE_ALIAS "ObjectGradientMaterialInstancing"
)
set_source_files_properties("qml/resources/PointMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "PointMaterial"
)
set_source_files_properties("qml/resources/PointRangeGradientMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "PointRangeGradientMaterial"
)
set_source_files_properties("qml/resources/PointMaterialInstancing.qml"
    PROPERTIES QT_RESOURCE_ALIAS "PointMaterialInstancing"
)
set_source_files_properties("qml/resources/PointRangeGradientMaterialInstancing.qml"
    PROPERTIES QT_RESOURCE_ALIAS "PointRangeGradientMaterialInstancing"
)

set_source_files_properties("qml/resources/VolumeMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "VolumeMaterial"
)

set_source_files_properties("qml/resources/VolumeLowDefMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "VolumeLowDefMaterial"
)

set_source_files_properties("qml/resources/VolumeSliceMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "VolumeSliceMaterial"
)

set_source_files_properties("qml/resources/VolumeFrameMaterial.qml"
    PROPERTIES QT_RESOURCE_ALIAS "VolumeFrameMaterial"
)

set(qml_component_resources
    "qml/resources/DatapointSphere.qml"
    "qml/resources/DatapointCube.qml"
)

set(qml_axis_resurces
    "qml/resources/AxisLabel.qml"
    "qml/resources/GridLine.qml"
    "qml/resources/ItemLabel.qml"
    "qml/resources/TitleLabel.qml"
)

set(qml_material_resources
    "qml/resources/ObjectGradientMaterial.qml"
    "qml/resources/ObjectGradientMaterialInstancing.qml"
    "qml/resources/SurfaceMaterial.qml"
    "qml/resources/PointMaterial.qml"
    "qml/resources/PointRangeGradientMaterial.qml"
    "qml/resources/PointMaterialInstancing.qml"
    "qml/resources/PointRangeGradientMaterialInstancing.qml"
    "qml/resources/RangeGradientMaterial.qml"
    "qml/resources/RangeGradientMaterialInstancing.qml"
    "qml/resources/RangeGradientScatterMaterial.qml"
    "qml/resources/RangeGradientScatterMaterialInstancing.qml"
    "qml/resources/GridSurfaceMaterial.qml"
    "qml/resources/SurfaceSliceMaterial.qml"
    "qml/resources/SurfaceShadowNoTex.qml"
    "qml/resources/VolumeMaterial.qml"
    "qml/resources/VolumeLowDefMaterial.qml"
    "qml/resources/VolumeSliceMaterial.qml"
    "qml/resources/VolumeFrameMaterial.qml"
)

set(resources
    "qml/designer/Graphs.metainfo"
    "qml/designer/images/bars3d-icon.png"
    "qml/designer/images/bars3d-icon16.png"
    "qml/designer/images/scatter3d-icon.png"
    "qml/designer/images/scatter3d-icon16.png"
    "qml/designer/images/surface3d-icon.png"
    "qml/designer/images/surface3d-icon16.png"
)

set_source_files_properties("engine/meshes/arrowFlat.obj"
    PROPERTIES QT_RESOURCE_ALIAS "arrow"
)
set_source_files_properties("engine/meshes/arrowSmooth.obj"
    PROPERTIES QT_RESOURCE_ALIAS "arrowSmooth"
)
set_source_files_properties("engine/meshes/background.obj"
    PROPERTIES QT_RESOURCE_ALIAS "background"
)
set_source_files_properties("engine/meshes/backgroundNoFloor.obj"
    PROPERTIES QT_RESOURCE_ALIAS "backgroundNoFloor"
)
set_source_files_properties("engine/meshes/barFilledFlat.obj"
    PROPERTIES QT_RESOURCE_ALIAS "bevelbarFull"
)
set_source_files_properties("engine/meshes/barFilledSmooth.obj"
    PROPERTIES QT_RESOURCE_ALIAS "bevelbarSmoothFull"
)
set_source_files_properties("engine/meshes/barFlat.obj"
    PROPERTIES QT_RESOURCE_ALIAS "bevelbar"
)
set_source_files_properties("engine/meshes/barSmooth.obj"
    PROPERTIES QT_RESOURCE_ALIAS "bevelbarSmooth"
)
set_source_files_properties("engine/meshes/coneFilledFlat.obj"
    PROPERTIES QT_RESOURCE_ALIAS "coneFull"
)

=== tests/auto/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only WITH Qt-GPL-exception-1.0

if(NOT ANDROID)
    add_subdirectory(cpptest)
endif()
if(TARGET Qt::Quick AND NOT boot2qt)
    add_subdirectory(qmltest)
endif()

=== tests/auto/cpptest/qgscatter-modelproxy/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only WITH Qt-GPL-exception-1.0

qt_internal_add_test(tst_qgscatter_modelproxy
    SOURCES
        tst_proxy.cpp
    LIBRARIES
        Qt::Gui
        Qt::Widgets
        Qt::Graphs
)

=== tests/auto/cpptest/qgscatter-proxy/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only WITH Qt-GPL-exception-1.0

qt_internal_add_test(tst_qgscatter_proxy
    SOURCES
        tst_proxy.cpp
    LIBRARIES
        Qt::Gui
        Qt::Graphs
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-graphs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.6.3
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt Data Visualization module provides multiple graph types to visualize data in 3D space (mingw-w64)'
arch=(any)
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgraphs.git"
msys2_references=(
  'archlinux: qt6-graphs'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:BSD-3-Clause WITH Qt-GPL-exception-1.0 AND GPL-3.0-only AND GFDL-1.3-no-invariants-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('22c25c34a75a57398d65a449fe8492d8cfe000edc7378e78325f08ba8c56edde')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-graphs() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-quick3d")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-graphs-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
